unit SymbolSize;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Printers, Menus, Clipbrd, StdCtrls;

type
  TSymbolSizeForm = class(TForm)
    PopupMenu1: TPopupMenu;
    Print1: TMenuItem;
    Copy1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    S: String;
  end;

var
  SymbolSizeForm: TSymbolSizeForm;

implementation

uses Frame;

{$R *.DFM}

procedure TSymbolSizeForm.FormShow(Sender: TObject);
var
  r: Integer;             // ̔{
  sx, sy: Integer;        // ʂ DPI l
  px, py: Integer;        // v^ DPI l
  sf: Integer;            // v^̃XP[t@N^
  tm, bm, lm, rm: Double; // ㉺E̗]̃TCY
  W, H: Double;
begin
  FrameForm.PaperInfo := FrameForm.CollectPaperInfo; // ݂̎𓾂B

  { ̔{擾B}
  r := FrameForm.UpDown8.Position;
  { ʂ DPIl擾B}
  sx := GetDeviceCaps(Label1.Canvas.Handle, LOGPIXELSX);
  sy := GetDeviceCaps(Label1.Canvas.Handle, LOGPIXELSY);
  { v^ DPIl擾B}
  px := FrameForm.PaperInfo.DPI.cx;
  py := FrameForm.PaperInfo.DPI.cy;
  { v^̃XP[t@N^擾B}
  sf := FrameForm.PaperInfo.ScaleFactor;

  S := #13#10 + '  ʏ̃V{ 1 ̃TCY' + #13#10;
  W := FrameForm.QRCode1.SymbolWidth;
  H := FrameForm.QRCode1.SymbolHeight;
  S := S + '    ' + IntToStr(Round(W)) + '~' + IntToStr(Round(H)) + ' pixel' + #13#10;
  W := W / sx * 25.4;
  H := H / sy * 25.4;
  S := S + Format('    %f~%f mm', [W, H]) + #13#10#13#10;

  S := S + '  ̃V{ 1 ̃TCY' + #13#10;
  W := FrameForm.QRCode1.SymbolWidth * px / sx * r / 100;
  H := FrameForm.QRCode1.SymbolHeight * py / sy * r / 100;
  S := S + '    ' + IntToStr(Round(W)) + '~' + IntToStr(Round(H)) + ' pixel' + #13#10;
  W := W / px * 25.4 * sf / 100;
  H := H / py * 25.4 * sf / 100;
  S := S + Format('    %f~%f mm', [W, H]) + #13#10#13#10;

  S := S + '  p̃TCY' + #13#10;
  W := FrameForm.PaperInfo.PaperSize.Width;
  H := FrameForm.PaperInfo.PaperSize.Height;
  S := S + '    ' + IntToStr(Round(W)) + '~' + IntToStr(Round(H)) + ' pixel' + #13#10;
  W := FrameForm.PaperInfo.TrueMMPaperSize.Width;
  H := FrameForm.PaperInfo.TrueMMPaperSize.Height;
  S := S + Format('    %f~%f mm', [W, H]) + #13#10#13#10;

  S := S + '  p̏㉺E̗]̃TCY' + #13#10;
  tm := FrameForm.PaperInfo.TopMargin;
  bm := FrameForm.PaperInfo.BottomMargin;
  lm := FrameForm.PaperInfo.LeftMargin;
  rm := FrameForm.PaperInfo.RightMargin;
  S := S + '    ' + IntToStr(Round(tm)) + ',  ' + IntToStr(Round(bm)) + ',  '
                  + IntToStr(Round(lm)) + ',  ' + IntToStr(Round(rm))
                  + ' pixel' + #13#10;
  tm := FrameForm.PaperInfo.TrueMMTopMargin;
  bm := FrameForm.PaperInfo.TrueMMBottomMargin;
  lm := FrameForm.PaperInfo.TrueMMLeftMargin;
  rm := FrameForm.PaperInfo.TrueMMRightMargin;
  S := S + Format('    %f,  %f,  %f,  %f mm', [tm, bm, lm, rm]) + #13#10#13#10;

  S := S + '  ł̈Jn_' + #13#10;
  W := FrameForm.PaperInfo.LeftMargin + FrameForm.startx;
  H := FrameForm.PaperInfo.TopMargin + FrameForm.starty;
  S := S + '    ( ' + IntToStr(Round(W)) + ',  ' + IntToStr(Round(H)) + ' ) pixel' + #13#10;
  W := FrameForm.PaperInfo.TrueMMLeftMargin + FrameForm.startx / px * 25.4 * sf / 100;
  H := FrameForm.PaperInfo.TrueMMTopMargin + FrameForm.starty / px * 25.4 * sf / 100;
  S := S + Format('    ( %f,  %f ) mm', [W, H]) + #13#10#13#10;

  S := S + '  ʂ DPI l' + #13#10;
  S := S + '    ' + IntToStr(sx) + '~' + IntToStr(sy) + ' dot per inch' + #13#10#13#10;

  S := S + '  v^ DPI l' + #13#10;
  S := S + '    ' + IntToStr(px) + '~' + IntToStr(py) + ' dot per inch' + #13#10#13#10;

  S := S + '  v^̃XP[t@N^' + #13#10;
  S := S + '    ' + IntToStr(sf) + ' %' + #13#10#13#10;

  S := S + '  Ql' + #13#10 + '    1 inch = 25.4 mm' + #13#10#13#10;

  S := S + '  V{̃TCÝAV{̔{( '
         + IntToStr(FrameForm.QRCode1.Pxmag) + ' )  ' + #13#10;
  S := S + '  ƈ̔{( ' + IntToStr(FrameForm.UpDown8.Position)
         + ' % )Ō܂܂B  ' + #13#10;

  Label1.Caption := S;
  ClientWidth := Label1.Width + 12;
  ClientHeight := Label1.Height + 12;
  S := '///// ݂̃V{̃TCY /////' + #13#10#13#10 + S;
end;

procedure TSymbolSizeForm.Print1Click(Sender: TObject);
var
  W, H: Integer;
  R: TRect;
begin
  Printer.BeginDoc;
  Printer.Canvas.Font.Size := 12;
  W := GetDeviceCaps(Printer.Canvas.Handle, PHYSICALWIDTH);
  H := GetDeviceCaps(Printer.Canvas.Handle, PHYSICALHEIGHT);
  R := Rect(W div 16, H div 16, W, H);
  DrawText(Printer.Canvas.Handle, PChar(S), -1, R,
           DT_WORDBREAK or DT_EXTERNALLEADING);
  Printer.EndDoc;
end;

procedure TSymbolSizeForm.Copy1Click(Sender: TObject);
begin
  Clipboard.AsText := S;
end;

procedure TSymbolSizeForm.Close1Click(Sender: TObject);
begin
  Close;
end;

end.
